import pandas as pd

class FiinIndicator:
    class trend:
        class EMA:
            def __init__(self, column: pd.Series, window: int) -> None: ...
            def ema(self) -> pd.Series: ...

        class SMA:
            def __init__(self, column: pd.Series, window: int) -> None: ...
            def sma(self) -> pd.Series: ...

        class WMA:
            def __init__(self, close: pd.Series, window: int = 9) -> None: ...
            def wma(self) -> pd.Series: ...

        class MACD:
            def __init__(self, column: pd.Series, window_slow: int = 26, window_fast: int = 12, window_sign: int = 9) -> None: ...
            def macd(self) -> pd.Series: ...
            def macd_signal(self) -> pd.Series: ...
            def macd_diff(self) -> pd.Series: ...

        class ADX:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14) -> None: ...
            def adx(self) -> pd.Series: ...
            def adx_pos(self) -> pd.Series: ...
            def adx_neg(self) -> pd.Series: ...

    class momentum:
        class RSI:
            def __init__(self, column: pd.Series, window: int = 14) -> None: ...
            def rsi(self) -> pd.Series: ...

        class Stochastic:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14, smooth_window: int = 3) -> None: ...
            def stoch(self) -> pd.Series: ...
            def stoch_signal(self) -> pd.Series: ...

    class volatility:
        class BollingerBands:
            def __init__(self, column: pd.Series, window: int = 20, window_dev: int = 2) -> None: ...
            def bollinger_hband(self) -> pd.Series: ...
            def bollinger_lband(self) -> pd.Series: ...

        class Supertrend:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14, multiplier: float = 3.0) -> None: ...
            def supertrend(self) -> pd.Series: ...
            def supertrend_hband(self) -> pd.Series: ...
            def supertrend_lband(self) -> pd.Series: ...

        class ATR:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14) -> None: ...
            def atr(self) -> pd.Series: ...

    class volume:
        class MFI:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, volume: pd.Series, window: int = 14) -> None: ...
            def mfi(self) -> pd.Series: ...

        class OBV:
            def __init__(self, column: pd.Series, volume: pd.Series) -> None: ...
            def obv(self) -> pd.Series: ...

        class VWAP:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, volume: pd.Series, window: int = 14) -> None: ...
            def vwap(self) -> pd.Series: ...